--- old/usr/src/uts/common/io/fibre-channel/fca/qlc/ql_api.c	Mon Aug  5 17:28:23 2019
+++ new/usr/src/uts/common/io/fibre-channel/fca/qlc/ql_api.c	Mon Aug  5 17:28:23 2019
@@ -9189,7 +9639,7 @@
 {
 	int sendup = 1;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	DEVICE_QUEUE_LOCK(tq);
 
@@ -9221,6 +9671,7 @@
 		DEVICE_QUEUE_LOCK(tq);
 
 		if (tq->outcnt) {
+			EL(ha, "busy tq->outcnt=%d\n", tq->outcnt);
 			sendup = 0;
 		} else {
 			tq->flags &= ~TQF_RSCN_RCVD;
@@ -9237,7 +9688,7 @@
 
 	DEVICE_QUEUE_UNLOCK(tq);
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 
 	return (sendup);
 }
@@ -9254,7 +9705,7 @@
 	ql_mbx_data_t		mr;
 	ql_head_t		done_q = { NULL, NULL };
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	list_size = sizeof (ql_dev_id_list_t) * DEVICE_LIST_ENTRIES;
 	list = kmem_zalloc(list_size, KM_SLEEP);
@@ -9292,7 +9743,8 @@
 			tq = ql_dev_init(ha, d_id, loop_id);
 
 			/* Test for fabric device. */
-			if (d_id.b.domain != ha->d_id.b.domain ||
+			if (ha->topology & QL_F_PORT ||
+			    d_id.b.domain != ha->d_id.b.domain ||
 			    d_id.b.area != ha->d_id.b.area) {
 				tq->flags |= TQF_FABRIC_DEVICE;
 			}
@@ -9317,7 +9769,7 @@
 	ADAPTER_STATE_UNLOCK(ha);
 
 	if (done_q.first != NULL) {
-		ql_done(done_q.first);
+		ql_done(done_q.first, B_FALSE);
 	}
 
 	kmem_free(list, list_size);
@@ -9326,7 +9778,7 @@
 		EL(ha, "failed=%xh\n", rval);
 	} else {
 		/*EMPTY*/
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_3(ha, "done\n");
 	}
 
 	return (rval);
@@ -9350,15 +9802,13 @@
 	ql_srb_t	*sp;
 	int		status;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	sp = ubp->ub_fca_private;
 	if (sp->ub_type == FC_TYPE_IS8802_SNAP) {
 		/* Disconnect IP from system buffers. */
 		if (ha->flags & IP_INITIALIZED) {
-			ADAPTER_STATE_UNLOCK(ha);
 			status = ql_shutdown_ip(ha);
-			ADAPTER_STATE_LOCK(ha);
 			if (status != QL_SUCCESS) {
 				cmn_err(CE_WARN,
 				    "!Qlogic %s(%d): Failed to shutdown IP",
@@ -9377,11 +9827,13 @@
 	kmem_free(sp, sizeof (ql_srb_t));
 	kmem_free(ubp, sizeof (fc_unsol_buf_t));
 
+	QL_UB_LOCK(ha);
 	if (ha->ub_allocated != 0) {
 		ha->ub_allocated--;
 	}
+	QL_UB_UNLOCK(ha);
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 }
 
 /*
@@ -9405,7 +9857,7 @@
 	ql_srb_t	*sp;
 	uint16_t	index;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	/* Locate a buffer to use. */
 	ubp = NULL;
@@ -9433,7 +9885,7 @@
 		ubp->ub_class = FC_TRAN_CLASS3;
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 
 	return (ubp);
 }
@@ -9463,7 +9915,7 @@
 	uint16_t	loop_id;
 	int		rval = QL_FUNCTION_FAILED;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	QL_UB_LOCK(ha);
 	if (index >= QL_UB_LIMIT || (ubp = ha->ub_array[index]) == NULL) {
@@ -9489,13 +9941,13 @@
 	    (sp->ub_type == FC_TYPE_IS8802_SNAP) &&
 	    (!(sp->flags & SRB_UB_ACQUIRED))) {
 		/* set broadcast D_ID */
-		loop_id = (uint16_t)(CFG_IST(ha, CFG_CTRL_24258081) ?
+		loop_id = (uint16_t)(CFG_IST(ha, CFG_ISP_FW_TYPE_2) ?
 		    BROADCAST_24XX_HDL : IP_BROADCAST_LOOP_ID);
 		if (tq->ub_loop_id == loop_id) {
 			if (ha->topology & QL_FL_PORT) {
 				ubp->ub_frame.d_id = 0x000000;
 			} else {
-				ubp->ub_frame.d_id = 0xffffff;
+				ubp->ub_frame.d_id = FS_BROADCAST;
 			}
 		} else {
 			ubp->ub_frame.d_id = ha->d_id.b24;
@@ -9533,20 +9985,13 @@
 			ubp->ub_frame.df_ctl = 0x20;
 		}
 
-		QL_PRINT_3(CE_CONT, "(%d): ub_frame.d_id=%xh\n",
-		    ha->instance, ubp->ub_frame.d_id);
-		QL_PRINT_3(CE_CONT, "(%d): ub_frame.s_id=%xh\n",
-		    ha->instance, ubp->ub_frame.s_id);
-		QL_PRINT_3(CE_CONT, "(%d): ub_frame.seq_cnt=%xh\n",
-		    ha->instance, ubp->ub_frame.seq_cnt);
-		QL_PRINT_3(CE_CONT, "(%d): ub_frame.seq_id=%xh\n",
-		    ha->instance, ubp->ub_frame.seq_id);
-		QL_PRINT_3(CE_CONT, "(%d): ub_frame.ro=%xh\n",
-		    ha->instance, ubp->ub_frame.ro);
-		QL_PRINT_3(CE_CONT, "(%d): ub_frame.f_ctl=%xh\n",
-		    ha->instance, ubp->ub_frame.f_ctl);
-		QL_PRINT_3(CE_CONT, "(%d): ub_bufsize=%xh\n",
-		    ha->instance, ubp->ub_bufsize);
+		QL_PRINT_3(ha, "ub_frame.d_id=%xh\n", ubp->ub_frame.d_id);
+		QL_PRINT_3(ha, "ub_frame.s_id=%xh\n", ubp->ub_frame.s_id);
+		QL_PRINT_3(ha, "ub_frame.seq_cnt=%xh\n", ubp->ub_frame.seq_cnt);
+		QL_PRINT_3(ha, "ub_frame.seq_id=%xh\n", ubp->ub_frame.seq_id);
+		QL_PRINT_3(ha, "ub_frame.ro=%xh\n", ubp->ub_frame.ro);
+		QL_PRINT_3(ha, "ub_frame.f_ctl=%xh\n", ubp->ub_frame.f_ctl);
+		QL_PRINT_3(ha, "ub_bufsize=%xh\n", ubp->ub_bufsize);
 		QL_DUMP_3(ubp->ub_buffer, 8,
 		    ubp->ub_bufsize < 64 ? ubp->ub_bufsize : 64);
 
@@ -9573,7 +10018,7 @@
 	}
 	QL_UB_UNLOCK(ha);
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 
 	return (rval);
 }
@@ -9592,48 +10037,48 @@
 ql_timer(void *arg)
 {
 	ql_link_t		*link;
-	uint32_t		set_flags;
-	uint32_t		reset_flags;
-	ql_adapter_state_t	*ha = NULL, *vha;
+	uint64_t		set_flags;
+	ql_adapter_state_t	*ha;
+	static uint32_t		sec_cnt = 0;
 
-	QL_PRINT_6(CE_CONT, "started\n");
+	QL_PRINT_6(NULL, "started\n");
 
 	/* Acquire global state lock. */
-	GLOBAL_STATE_LOCK();
+	GLOBAL_TIMER_LOCK();
 	if (ql_timer_timeout_id == NULL) {
 		/* Release global state lock. */
-		GLOBAL_STATE_UNLOCK();
+		GLOBAL_TIMER_UNLOCK();
 		return;
 	}
 
+	sec_cnt++;
 	for (link = ql_hba.first; link != NULL; link = link->next) {
 		ha = link->base_address;
 
-		/* Skip adapter if suspended of stalled. */
-		ADAPTER_STATE_LOCK(ha);
+		/* Skip adapter if suspended or stalled. */
 		if (ha->flags & ADAPTER_SUSPENDED ||
-		    ha->task_daemon_flags & DRIVER_STALL) {
-			ADAPTER_STATE_UNLOCK(ha);
+		    ha->task_daemon_flags & DRIVER_STALL ||
+		    !(ha->task_daemon_flags & FIRMWARE_UP)) {
 			continue;
 		}
-		ha->flags |= ADAPTER_TIMER_BUSY;
-		ADAPTER_STATE_UNLOCK(ha);
 
 		QL_PM_LOCK(ha);
 		if (ha->power_level != PM_LEVEL_D0) {
 			QL_PM_UNLOCK(ha);
-
-			ADAPTER_STATE_LOCK(ha);
-			ha->flags &= ~ADAPTER_TIMER_BUSY;
-			ADAPTER_STATE_UNLOCK(ha);
 			continue;
 		}
-		ha->busy++;
+		ha->pm_busy++;
 		QL_PM_UNLOCK(ha);
 
 		set_flags = 0;
-		reset_flags = 0;
 
+		/* All completion treads busy, wake up a helper thread. */
+		if (ha->comp_thds_awake == ha->comp_thds_active &&
+		    ha->comp_q.first != NULL) {
+			QL_PRINT_10(ha, "comp queue helper thrd started\n");
+			(void) timeout(ql_process_comp_queue, (void *)ha, 1);
+		}
+
 		/* Port retry timer handler. */
 		if (LOOP_READY(ha)) {
 			ADAPTER_STATE_LOCK(ha);
@@ -9657,8 +10102,9 @@
 				if (ha->loop_down_timer == LOOP_DOWN_RESET) {
 					if (CFG_IST(ha,
 					    CFG_DUMP_LOOP_OFFLINE_TIMEOUT)) {
-						(void) ql_binary_fw_dump(ha,
-						    TRUE);
+						ADAPTER_STATE_LOCK(ha);
+						ha->flags |= FW_DUMP_NEEDED;
+						ADAPTER_STATE_UNLOCK(ha);
 					}
 					EL(ha, "loop_down_reset, "
 					    "isp_abort_needed\n");
@@ -9683,14 +10129,7 @@
 				} else if (LOOP_READY(ha)) {
 					ha->watchdog_timer--;
 					if (ha->watchdog_timer == 0) {
-						for (vha = ha; vha != NULL;
-						    vha = vha->vp_next) {
-							ql_watchdog(vha,
-							    &set_flags,
-							    &reset_flags);
-						}
-						ha->watchdog_timer =
-						    WATCHDOG_TIME;
+						set_flags |= WATCHDOG_NEEDED;
 					}
 				}
 			}
@@ -9711,34 +10150,20 @@
 				}
 			}
 		}
-		ADAPTER_STATE_LOCK(ha);
-		if (ha->idc_restart_timer != 0) {
-			ha->idc_restart_timer--;
-			if (ha->idc_restart_timer == 0) {
-				ha->idc_restart_cnt = 0;
-				reset_flags |= DRIVER_STALL;
-			}
+
+		if (CFG_IST(ha, CFG_CTRL_82XX) && ha->flags & ONLINE &&
+		    !(ha->task_daemon_flags & (ISP_ABORT_NEEDED |
+		    ABORT_ISP_ACTIVE)) &&
+		    !(sec_cnt % 2)) {
+			set_flags |= IDC_POLL_NEEDED;
 		}
-		if (ha->idc_flash_acc_timer != 0) {
-			ha->idc_flash_acc_timer--;
-			if (ha->idc_flash_acc_timer == 0 &&
-			    ha->idc_flash_acc != 0) {
-				ha->idc_flash_acc = 1;
-				ha->idc_mb[0] = MBA_IDC_NOTIFICATION;
-				ha->idc_mb[1] = 0;
-				ha->idc_mb[2] = IDC_OPC_DRV_START;
-				set_flags |= IDC_EVENT;
-			}
-		}
-		ADAPTER_STATE_UNLOCK(ha);
 
-		if (set_flags != 0 || reset_flags != 0) {
-			ql_awaken_task_daemon(ha, NULL, set_flags,
-			    reset_flags);
+		if (ha->ledstate.BeaconState == BEACON_ON) {
+			set_flags |= LED_BLINK;
 		}
 
-		if (ha->xioctl->ledstate.BeaconState == BEACON_ON) {
-			ql_blink_led(ha);
+		if (set_flags != 0) {
+			ql_awaken_task_daemon(ha, NULL, set_flags, 0);
 		}
 
 		/* Update the IO stats */
@@ -9754,16 +10179,10 @@
 			ha->xioctl->IOOutputByteCnt %= 0x100000;
 		}
 
-		if (CFG_IST(ha, CFG_CTRL_8021)) {
-			(void) ql_8021_idc_handler(ha);
-		}
-
-		ADAPTER_STATE_LOCK(ha);
-		ha->flags &= ~ADAPTER_TIMER_BUSY;
-		ADAPTER_STATE_UNLOCK(ha);
-
 		QL_PM_LOCK(ha);
-		ha->busy--;
+		if (ha->pm_busy) {
+			ha->pm_busy--;
+		}
 		QL_PM_UNLOCK(ha);
 	}
 
@@ -9773,9 +10192,9 @@
 	}
 
 	/* Release global state lock. */
-	GLOBAL_STATE_UNLOCK();
+	GLOBAL_TIMER_UNLOCK();
 
-	QL_PRINT_6(CE_CONT, "done\n");
+	QL_PRINT_6(ha, "done\n");
 }
 
 /*
@@ -9799,7 +10218,7 @@
 static void
 ql_timeout_insert(ql_adapter_state_t *ha, ql_tgt_t *tq, ql_srb_t *sp)
 {
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	if (sp->pkt->pkt_timeout != 0 && sp->pkt->pkt_timeout < 0x10000) {
 		sp->isp_timeout = (uint16_t)(sp->pkt->pkt_timeout);
@@ -9838,7 +10257,7 @@
 		sp->init_wdg_q_time = 0;
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 }
 
 /*
@@ -9850,111 +10269,143 @@
  *	has occurred command will be aborted.
  *
  * Input:
- *	ha:		adapter state pointer.
- *	set_flags:	task daemon flags to set.
- *	reset_flags:	task daemon flags to reset.
+ *	ha:	adapter state pointer.
  *
  * Context:
- *	Interrupt context, no mailbox commands allowed.
+ *	Kernel context.
  */
 static void
-ql_watchdog(ql_adapter_state_t *ha, uint32_t *set_flags, uint32_t *reset_flags)
+ql_watchdog(ql_adapter_state_t *ha)
 {
-	ql_srb_t	*sp;
-	ql_link_t	*link;
-	ql_link_t	*next_cmd;
-	ql_link_t	*next_device;
-	ql_tgt_t	*tq;
-	ql_lun_t	*lq;
-	uint16_t	index;
-	int		q_sane;
+	ql_link_t		*link;
+	ql_tgt_t		*tq;
+	uint16_t		index;
+	ql_adapter_state_t	*vha;
 
-	QL_PRINT_6(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_6(ha, "started\n");
 
-	/* Loop through all targets. */
-	for (index = 0; index < DEVICE_HEAD_LIST_SIZE; index++) {
-		for (link = ha->dev[index].first; link != NULL;
-		    link = next_device) {
-			tq = link->base_address;
+	for (vha = ha; vha != NULL; vha = vha->vp_next) {
+		/* Loop through all targets. */
+		for (index = 0; index < DEVICE_HEAD_LIST_SIZE; index++) {
+			for (link = vha->dev[index].first; link != NULL;
+			    link = link->next) {
+				tq = link->base_address;
 
-			/* Try to acquire device queue lock. */
-			if (TRY_DEVICE_QUEUE_LOCK(tq) == 0) {
-				next_device = NULL;
-				continue;
-			}
+				/* Try to acquire device queue lock. */
+				if (TRY_DEVICE_QUEUE_LOCK(tq) == 0) {
+					break;
+				}
 
-			next_device = link->next;
-
-			if (!(CFG_IST(ha, CFG_ENABLE_LINK_DOWN_REPORTING)) &&
-			    (tq->port_down_retry_count == 0)) {
-				/* Release device queue lock. */
-				DEVICE_QUEUE_UNLOCK(tq);
-				continue;
+				if (!(CFG_IST(ha,
+				    CFG_ENABLE_LINK_DOWN_REPORTING)) &&
+				    (tq->port_down_retry_count == 0)) {
+					/* Release device queue lock. */
+					DEVICE_QUEUE_UNLOCK(tq);
+					continue;
+				}
+				ql_wdg_tq_list(vha, tq);
 			}
+		}
+	}
+	ha->watchdog_timer = WATCHDOG_TIME;
 
-			/* Find out if this device is in a sane state. */
-			if (tq->flags & (TQF_RSCN_RCVD |
-			    TQF_NEED_AUTHENTICATION | TQF_QUEUE_SUSPENDED)) {
-				q_sane = 0;
-			} else {
-				q_sane = 1;
-			}
-			/* Loop through commands on watchdog queue. */
-			for (link = tq->wdg.first; link != NULL;
-			    link = next_cmd) {
-				next_cmd = link->next;
-				sp = link->base_address;
-				lq = sp->lun_queue;
+	QL_PRINT_6(ha, "done\n");
+}
 
-				/*
-				 * For SCSI commands, if everything seems to
-				 * be going fine and this packet is stuck
-				 * because of throttling at LUN or target
-				 * level then do not decrement the
-				 * sp->wdg_q_time
-				 */
-				if (ha->task_daemon_flags & STATE_ONLINE &&
-				    (sp->flags & SRB_ISP_STARTED) == 0 &&
-				    q_sane && sp->flags & SRB_FCP_CMD_PKT &&
-				    lq->lun_outcnt >= ha->execution_throttle) {
-					continue;
-				}
+/*
+ * ql_wdg_tq_list
+ *	Timeout handler that runs in interrupt context. The
+ *	ql_adapter_state_t * argument is the parameter set up when the
+ *	timeout was initialized (state structure pointer).
+ *	Function used to update timeout values and if timeout
+ *	has occurred command will be aborted.
+ *
+ * Input:
+ *	ha:	adapter state pointer.
+ *	tq:	target queue pointer.
+ *	DEVICE_QUEUE_LOCK must be already obtained.
+ *
+ * Output:
+ *	Releases DEVICE_QUEUE_LOCK upon exit.
+ *
+ * Context:
+ *	Kernel context.
+ */
+static void
+ql_wdg_tq_list(ql_adapter_state_t *ha, ql_tgt_t *tq)
+{
+	ql_srb_t	*sp;
+	ql_link_t	*link, *next_cmd;
+	ql_lun_t	*lq;
+	boolean_t	q_sane, timeout = B_FALSE;
 
-				if (sp->wdg_q_time != 0) {
-					sp->wdg_q_time--;
+	QL_PRINT_6(ha, "started\n");
 
-					/* Timeout? */
-					if (sp->wdg_q_time != 0) {
-						continue;
-					}
+	/* Find out if this device is in a sane state */
+	if (tq->flags & (TQF_RSCN_RCVD | TQF_NEED_AUTHENTICATION |
+	    TQF_QUEUE_SUSPENDED)) {
+		q_sane = B_FALSE;
+	} else {
+		q_sane = B_TRUE;
+	}
+	/* Loop through commands on watchdog queue. */
+	for (link = tq->wdg.first; link != NULL; link = next_cmd) {
+		next_cmd = link->next;
+		sp = link->base_address;
+		lq = sp->lun_queue;
 
-					ql_remove_link(&tq->wdg, &sp->wdg);
-					sp->flags &= ~SRB_WATCHDOG_ENABLED;
+		/*
+		 * For SCSI commands, if everything
+		 * seems to * be going fine and this
+		 * packet is stuck
+		 * because of throttling at LUN or
+		 * target level then do not decrement
+		 * the sp->wdg_q_time
+		 */
+		if (ha->task_daemon_flags & STATE_ONLINE &&
+		    !(sp->flags & SRB_ISP_STARTED) &&
+		    q_sane == B_TRUE &&
+		    sp->flags & SRB_FCP_CMD_PKT &&
+		    lq->lun_outcnt >= ha->execution_throttle) {
+			continue;
+		}
 
-					if (sp->flags & SRB_ISP_STARTED) {
-						ql_cmd_timeout(ha, tq, sp,
-						    set_flags, reset_flags);
+		if (sp->wdg_q_time != 0) {
+			sp->wdg_q_time--;
 
-						DEVICE_QUEUE_UNLOCK(tq);
-						tq = NULL;
-						next_cmd = NULL;
-						next_device = NULL;
-						index = DEVICE_HEAD_LIST_SIZE;
-					} else {
-						ql_cmd_timeout(ha, tq, sp,
-						    set_flags, reset_flags);
-					}
-				}
+			/* Timeout? */
+			if (sp->wdg_q_time != 0) {
+				continue;
 			}
 
-			/* Release device queue lock. */
-			if (tq != NULL) {
-				DEVICE_QUEUE_UNLOCK(tq);
+			sp->flags |= SRB_COMMAND_TIMEOUT;
+			timeout = B_TRUE;
+		}
+	}
+
+	/*
+	 * Loop through commands on watchdog queue and
+	 * abort timed out commands.
+	 */
+	if (timeout == B_TRUE) {
+		for (link = tq->wdg.first; link != NULL; link = next_cmd) {
+			sp = link->base_address;
+			next_cmd = link->next;
+
+			if (sp->flags & SRB_COMMAND_TIMEOUT) {
+				ql_remove_link(&tq->wdg, &sp->wdg);
+				sp->flags &= ~(SRB_WATCHDOG_ENABLED |
+				    SRB_COMMAND_TIMEOUT);
+				ql_cmd_timeout(ha, tq, sp);
+				next_cmd = tq->wdg.first;
 			}
 		}
 	}
 
-	QL_PRINT_6(CE_CONT, "(%d): done\n", ha->instance);
+	/* Release device queue lock. */
+	DEVICE_QUEUE_UNLOCK(tq);
+
+	QL_PRINT_6(ha, "done\n");
 }
 
 /*
@@ -9965,25 +10416,22 @@
  *	ha:		adapter state pointer.
  *	tq:		target queue pointer.
  *	sp:		SRB pointer.
- *	set_flags:	task daemon flags to set.
- *	reset_flags:	task daemon flags to reset.
  *
  * Context:
- *	Interrupt context, no mailbox commands allowed.
+ *	Kernel context.
  */
-/* ARGSUSED */
 static void
-ql_cmd_timeout(ql_adapter_state_t *ha, ql_tgt_t *tq, ql_srb_t *sp,
-    uint32_t *set_flags, uint32_t *reset_flags)
+ql_cmd_timeout(ql_adapter_state_t *ha, ql_tgt_t *tq, ql_srb_t *sp)
 {
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	int	rval = 0;
 
+	QL_PRINT_3(ha, "started\n");
+
+	REQUEST_RING_LOCK(ha);
 	if (!(sp->flags & SRB_ISP_STARTED)) {
+		EL(ha, "command timed out in driver, sp=%ph spf=%xh\n",
+		    (void *)sp, sp->flags);
 
-		EL(ha, "command timed out in driver = %ph\n", (void *)sp);
-
-		REQUEST_RING_LOCK(ha);
-
 		/* if it's on a queue */
 		if (sp->cmd.head) {
 			/*
@@ -10005,69 +10453,34 @@
 		sp->flags &= ~SRB_RETRY;
 
 		/* Call done routine to handle completion. */
-		ql_done(&sp->cmd);
+		ql_done(&sp->cmd, B_FALSE);
+	} else if (CFG_IST(ha, CFG_CTRL_82XX)) {
+		REQUEST_RING_UNLOCK(ha);
+		DEVICE_QUEUE_UNLOCK(tq);
 
-		DEVICE_QUEUE_LOCK(tq);
-	} else if (CFG_IST(ha, CFG_CTRL_8021)) {
-		int		rval;
-		uint32_t	index;
-
 		EL(ha, "command timed out in isp=%ph, osc=%ph, index=%xh, "
 		    "spf=%xh\n", (void *)sp,
 		    (void *)ha->outstanding_cmds[sp->handle & OSC_INDEX_MASK],
 		    sp->handle & OSC_INDEX_MASK, sp->flags);
 
-		DEVICE_QUEUE_UNLOCK(tq);
-
-		INTR_LOCK(ha);
-		ha->pha->xioctl->ControllerErrorCount++;
-		if (sp->handle) {
-			ha->pha->timeout_cnt++;
-			index = sp->handle & OSC_INDEX_MASK;
-			if (ha->pha->outstanding_cmds[index] == sp) {
-				sp->request_ring_ptr->entry_type =
-				    INVALID_ENTRY_TYPE;
-				sp->request_ring_ptr->entry_count = 0;
-				ha->pha->outstanding_cmds[index] = 0;
-			}
-			INTR_UNLOCK(ha);
-
-			rval = ql_abort_command(ha, sp);
-			if (rval == QL_FUNCTION_TIMEOUT ||
-			    rval == QL_LOCK_TIMEOUT ||
-			    rval == QL_FUNCTION_PARAMETER_ERROR ||
-			    ha->pha->timeout_cnt > TIMEOUT_THRESHOLD) {
-				*set_flags |= ISP_ABORT_NEEDED;
-				EL(ha, "abort status=%xh, tc=%xh, isp_abort_"
-				    "needed\n", rval, ha->pha->timeout_cnt);
-			}
-
-			sp->handle = 0;
-			sp->flags &= ~SRB_IN_TOKEN_ARRAY;
-		} else {
-			INTR_UNLOCK(ha);
+		if (ha->pha->timeout_cnt++ > TIMEOUT_THRESHOLD ||
+		    (rval = ql_abort_io(ha, sp)) != QL_SUCCESS) {
+			sp->flags |= SRB_COMMAND_TIMEOUT;
+			TASK_DAEMON_LOCK(ha);
+			ha->task_daemon_flags |= ISP_ABORT_NEEDED;
+			TASK_DAEMON_UNLOCK(ha);
+			EL(ha, "abort status=%xh, tc=%xh, isp_abort_"
+			    "needed\n", rval, ha->pha->timeout_cnt);
 		}
-
-		/* Set timeout status */
-		sp->pkt->pkt_reason = CS_TIMEOUT;
-
-		/* Ensure no retry */
-		sp->flags &= ~SRB_RETRY;
-
-		/* Call done routine to handle completion. */
-		ql_done(&sp->cmd);
-
-		DEVICE_QUEUE_LOCK(tq);
-
 	} else {
+		REQUEST_RING_UNLOCK(ha);
+		DEVICE_QUEUE_UNLOCK(tq);
+
 		EL(ha, "command timed out in isp=%ph, osc=%ph, index=%xh, "
 		    "spf=%xh, isp_abort_needed\n", (void *)sp,
 		    (void *)ha->outstanding_cmds[sp->handle & OSC_INDEX_MASK],
 		    sp->handle & OSC_INDEX_MASK, sp->flags);
 
-		/* Release device queue lock. */
-		DEVICE_QUEUE_UNLOCK(tq);
-
 		INTR_LOCK(ha);
 		ha->pha->xioctl->ControllerErrorCount++;
 		INTR_UNLOCK(ha);
@@ -10076,39 +10489,21 @@
 		sp->flags |= SRB_COMMAND_TIMEOUT;
 
 		if (CFG_IST(ha, CFG_DUMP_DRIVER_COMMAND_TIMEOUT)) {
-			(void) ql_binary_fw_dump(ha, TRUE);
+			ADAPTER_STATE_LOCK(ha);
+			ha->flags |= FW_DUMP_NEEDED;
+			ADAPTER_STATE_UNLOCK(ha);
 		}
 
-		*set_flags |= ISP_ABORT_NEEDED;
-
-		DEVICE_QUEUE_LOCK(tq);
+		TASK_DAEMON_LOCK(ha);
+		ha->task_daemon_flags |= ISP_ABORT_NEEDED;
+		TASK_DAEMON_UNLOCK(ha);
 	}
+	DEVICE_QUEUE_LOCK(tq);
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 }
 
 /*
- * ql_rst_aen
- *	Processes asynchronous reset.
- *
- * Input:
- *	ha = adapter state pointer.
- *
- * Context:
- *	Kernel context.
- */
-static void
-ql_rst_aen(ql_adapter_state_t *ha)
-{
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
-
-	/* Issue marker command. */
-	(void) ql_marker(ha, 0, 0, MK_SYNC_ALL);
-
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
-}
-
-/*
  * ql_cmd_wait
  *	Stall driver until all outstanding commands are returned.
  *
@@ -10126,7 +10521,7 @@
 	ql_tgt_t		*tq;
 	ql_adapter_state_t	*vha;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	/* Wait for all outstanding commands to be returned. */
 	(void) ql_wait_outstanding(ha);
@@ -10141,7 +10536,8 @@
 				tq = link->base_address;
 				if (tq &&
 				    (!(tq->prli_svc_param_word_3 &
-				    PRLI_W3_RETRY))) {
+				    PRLI_W3_RETRY) ||
+				    ha->task_daemon_flags & ABORT_ISP_ACTIVE)) {
 					(void) ql_abort_device(vha, tq, 0);
 				}
 			}
@@ -10148,7 +10544,7 @@
 		}
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 }
 
 /*
@@ -10170,28 +10566,30 @@
 	ql_srb_t	*sp;
 	uint16_t	index, count;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	count = ql_osc_wait_count;
-	for (index = 1; index < MAX_OUTSTANDING_COMMANDS; index++) {
+	for (index = 1; index < ha->pha->osc_max_cnt; index++) {
 		if (ha->pha->pending_cmds.first != NULL) {
 			ql_start_iocb(ha, NULL);
 			index = 1;
 		}
 		if ((sp = ha->pha->outstanding_cmds[index]) != NULL &&
+		    sp != QL_ABORTED_SRB(ha) &&
 		    (sp->flags & SRB_COMMAND_TIMEOUT) == 0) {
 			if (count-- != 0) {
 				ql_delay(ha, 10000);
 				index = 0;
 			} else {
-				EL(ha, "failed, sp=%ph, oci=%d, hdl=%xh\n",
-				    (void *)sp, index, sp->handle);
+				EL(ha, "still in OSC,sp=%ph,oci=%d,sph=%xh,"
+				    "spf=%xh\n", (void *) sp, index, sp->handle,
+				    sp->flags);
 				break;
 			}
 		}
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 
 	return (index);
 }
@@ -10207,7 +10605,7 @@
  * Context:
  *	Interrupt or Kernel context, no mailbox commands allowed.
  */
-static void
+void
 ql_restart_queues(ql_adapter_state_t *ha)
 {
 	ql_link_t		*link, *link2;
@@ -10216,7 +10614,7 @@
 	uint16_t		index;
 	ql_adapter_state_t	*vha;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	for (vha = ha->pha; vha != NULL; vha = vha->vp_next) {
 		for (index = 0; index < DEVICE_HEAD_LIST_SIZE; index++) {
@@ -10245,7 +10643,7 @@
 		}
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 }
 
 /*
@@ -10268,10 +10666,10 @@
 	char		buf[256];
 	uint32_t	data;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
-	if ((CFG_IST(ha, CFG_CTRL_242581)) == 0) {
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	if (!CFG_IST(ha, CFG_IIDMA_SUPPORT)) {
+		QL_PRINT_3(ha, "done\n");
 		return;
 	}
 
@@ -10280,79 +10678,75 @@
 		    link = link->next) {
 			tq = link->base_address;
 
-			/* Acquire device queue lock. */
-			DEVICE_QUEUE_LOCK(tq);
-
 			if ((tq->flags & TQF_IIDMA_NEEDED) == 0) {
-				DEVICE_QUEUE_UNLOCK(tq);
 				continue;
 			}
 
+			/* Acquire device queue lock. */
+			DEVICE_QUEUE_LOCK(tq);
+
 			tq->flags &= ~TQF_IIDMA_NEEDED;
 
+			/* Release device queue lock. */
+			DEVICE_QUEUE_UNLOCK(tq);
+
 			if ((tq->loop_id > LAST_N_PORT_HDL) ||
+			    (tq->d_id.b24 == FS_MANAGEMENT_SERVER) ||
+			    (tq->flags & TQF_INITIATOR_DEVICE) ||
 			    (tq->iidma_rate == IIDMA_RATE_NDEF)) {
-				DEVICE_QUEUE_UNLOCK(tq);
 				continue;
 			}
 
 			/* Get the iiDMA persistent data */
-			if (tq->iidma_rate == IIDMA_RATE_INIT) {
-				(void) sprintf(buf,
-				    "iidma-rate-%02x%02x%02x%02x%02x"
-				    "%02x%02x%02x", tq->port_name[0],
-				    tq->port_name[1], tq->port_name[2],
-				    tq->port_name[3], tq->port_name[4],
-				    tq->port_name[5], tq->port_name[6],
-				    tq->port_name[7]);
+			(void) snprintf(buf, sizeof (buf),
+			    "iidma-rate-%02x%02x%02x%02x%02x"
+			    "%02x%02x%02x", tq->port_name[0],
+			    tq->port_name[1], tq->port_name[2],
+			    tq->port_name[3], tq->port_name[4],
+			    tq->port_name[5], tq->port_name[6],
+			    tq->port_name[7]);
 
-				if ((data = ql_get_prop(ha, buf)) ==
-				    0xffffffff) {
-					tq->iidma_rate = IIDMA_RATE_NDEF;
-				} else {
-					switch (data) {
-					case IIDMA_RATE_1GB:
-					case IIDMA_RATE_2GB:
-					case IIDMA_RATE_4GB:
-					case IIDMA_RATE_10GB:
-						tq->iidma_rate = data;
-						break;
-					case IIDMA_RATE_8GB:
-						if (CFG_IST(ha,
-						    CFG_CTRL_25XX)) {
-							tq->iidma_rate = data;
-						} else {
-							tq->iidma_rate =
-							    IIDMA_RATE_4GB;
-						}
-						break;
-					default:
-						EL(ha, "invalid data for "
-						    "parameter: %s: %xh\n",
-						    buf, data);
-						tq->iidma_rate =
-						    IIDMA_RATE_NDEF;
-						break;
-					}
+			if ((data = ql_get_prop(ha, buf)) ==
+			    0xffffffff) {
+				tq->iidma_rate = IIDMA_RATE_NDEF;
+			} else {
+				switch (data) {
+				case IIDMA_RATE_4GB:
+				case IIDMA_RATE_8GB:
+				case IIDMA_RATE_10GB:
+				case IIDMA_RATE_16GB:
+				case IIDMA_RATE_32GB:
+					tq->iidma_rate = data;
+					break;
+				default:
+					EL(ha, "invalid data for "
+					    "parameter: %s: %xh\n",
+					    buf, data);
+					tq->iidma_rate =
+					    IIDMA_RATE_NDEF;
+					break;
 				}
 			}
 
+			EL(ha, "d_id = %xh iidma_rate = %xh\n",
+			    tq->d_id.b24, tq->iidma_rate);
+
 			/* Set the firmware's iiDMA rate */
-			if (tq->iidma_rate <= IIDMA_RATE_MAX &&
-			    !(CFG_IST(ha, CFG_CTRL_8081))) {
-				data = ql_iidma_rate(ha, tq->loop_id,
-				    &tq->iidma_rate, EXT_IIDMA_MODE_SET);
-				if (data != QL_SUCCESS) {
-					EL(ha, "mbx failed: %xh\n", data);
+			if (!CFG_IST(ha, CFG_FCOE_SUPPORT)) {
+				if (tq->iidma_rate <= IIDMA_RATE_MAX) {
+					data = ql_iidma_rate(ha, tq->loop_id,
+					    &tq->iidma_rate,
+					    EXT_IIDMA_MODE_SET);
+					if (data != QL_SUCCESS) {
+						EL(ha, "mbx failed: %xh\n",
+						    data);
+					}
 				}
 			}
-
-			/* Release device queue lock. */
-			DEVICE_QUEUE_UNLOCK(tq);
 		}
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 }
 
 /*
@@ -10365,7 +10759,7 @@
  * Context:
  *	Interrupt or Kernel context, no mailbox commands allowed.
  */
-static void
+void
 ql_abort_queues(ql_adapter_state_t *ha)
 {
 	ql_link_t		*link;
@@ -10374,13 +10768,13 @@
 	uint16_t		index;
 	ql_adapter_state_t	*vha;
 
-	QL_PRINT_10(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_10(ha, "started\n");
 
 	/* Return all commands in outstanding command list. */
 	INTR_LOCK(ha);
 
 	/* Place all commands in outstanding cmd list on device queue. */
-	for (index = 1; index < MAX_OUTSTANDING_COMMANDS; index++) {
+	for (index = 1; index < ha->osc_max_cnt; index++) {
 		if (ha->pending_cmds.first != NULL) {
 			INTR_UNLOCK(ha);
 			ql_start_iocb(ha, NULL);
@@ -10391,10 +10785,16 @@
 		}
 		sp = ha->outstanding_cmds[index];
 
+		if (sp && (sp == QL_ABORTED_SRB(ha) || sp->ha != ha)) {
+			continue;
+		}
+
 		/* skip devices capable of FCP2 retrys */
-		if ((sp != NULL) &&
-		    ((tq = sp->lun_queue->target_queue) != NULL) &&
-		    (!(tq->prli_svc_param_word_3 & PRLI_W3_RETRY))) {
+		if (sp != NULL &&
+		    (sp->lun_queue == NULL ||
+		    (tq = sp->lun_queue->target_queue) == NULL ||
+		    !(tq->prli_svc_param_word_3 & PRLI_W3_RETRY) ||
+		    ha->task_daemon_flags & ABORT_ISP_ACTIVE)) {
 			ha->outstanding_cmds[index] = NULL;
 			sp->handle = 0;
 			sp->flags &= ~SRB_IN_TOKEN_ARRAY;
@@ -10407,7 +10807,7 @@
 
 			/* Call done routine to handle completions. */
 			sp->cmd.next = NULL;
-			ql_done(&sp->cmd);
+			ql_done(&sp->cmd, B_FALSE);
 
 			INTR_LOCK(ha);
 		}
@@ -10415,8 +10815,7 @@
 	INTR_UNLOCK(ha);
 
 	for (vha = ha; vha != NULL; vha = vha->vp_next) {
-		QL_PRINT_10(CE_CONT, "(%d,%d): abort instance\n",
-		    vha->instance, vha->vp_index);
+		QL_PRINT_10(vha, "abort instance\n");
 		for (index = 0; index < DEVICE_HEAD_LIST_SIZE; index++) {
 			for (link = vha->dev[index].first; link != NULL;
 			    link = link->next) {
@@ -10423,7 +10822,8 @@
 				tq = link->base_address;
 				/* skip devices capable of FCP2 retrys */
 				if (!(tq->prli_svc_param_word_3 &
-				    PRLI_W3_RETRY)) {
+				    PRLI_W3_RETRY) ||
+				    ha->task_daemon_flags & ABORT_ISP_ACTIVE) {
 					/*
 					 * Set port unavailable status and
 					 * return all commands on a devices
@@ -10434,7 +10834,7 @@
 			}
 		}
 	}
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 }
 
 /*
@@ -10454,9 +10854,10 @@
 	ql_srb_t	*sp;
 	ql_lun_t	*lq;
 
-	QL_PRINT_10(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_10(ha, "started\n");
 
 	DEVICE_QUEUE_LOCK(tq);
+	ql_requeue_pending_cmds(ha, tq);
 
 	for (lun_link = tq->lun_queues.first; lun_link != NULL;
 	    lun_link = lun_link->next) {
@@ -10466,11 +10867,6 @@
 		while (cmd_link != NULL) {
 			sp = cmd_link->base_address;
 
-			if (sp->flags & SRB_ABORT) {
-				cmd_link = cmd_link->next;
-				continue;
-			}
-
 			/* Remove srb from device cmd queue. */
 			ql_remove_link(&lq->cmd, &sp->cmd);
 
@@ -10482,7 +10878,7 @@
 			sp->pkt->pkt_reason = CS_PORT_UNAVAILABLE;
 
 			/* Call done routine to handle completion. */
-			ql_done(&sp->cmd);
+			ql_done(&sp->cmd, B_FALSE);
 
 			/* Delay for system */
 			ql_delay(ha, 10000);
@@ -10493,7 +10889,7 @@
 	}
 	DEVICE_QUEUE_UNLOCK(tq);
 
-	QL_PRINT_10(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_10(ha, "done\n");
 }
 
 /*
@@ -10504,18 +10900,15 @@
  *	ha = adapter state pointer.
  *	DEVICE_QUEUE_LOCK must be released.
  *
- * Returns:
- *	ql local function return status code.
- *
  * Context:
  *	Kernel context.
  */
-static int
+static void
 ql_loop_resync(ql_adapter_state_t *ha)
 {
 	int rval;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	if (ha->flags & IP_INITIALIZED) {
 		(void) ql_shutdown_ip(ha);
@@ -10530,12 +10923,10 @@
 	/* Set loop online, if it really is. */
 	if (rval == QL_SUCCESS) {
 		ql_loop_online(ha);
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_3(ha, "done\n");
 	} else {
 		EL(ha, "failed, rval = %xh\n", rval);
 	}
-
-	return (rval);
 }
 
 /*
@@ -10554,7 +10945,7 @@
 {
 	ql_adapter_state_t	*vha;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	/* Inform the FC Transport that the hardware is online. */
 	for (vha = ha->pha; vha != NULL; vha = vha->vp_next) {
@@ -10588,7 +10979,7 @@
 	/* Restart device queues that may have been stopped. */
 	ql_restart_queues(ha);
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 }
 
 /*
@@ -10629,7 +11020,7 @@
 
 	if (ha == NULL) {
 		/*EMPTY*/
-		QL_PRINT_2(CE_CONT, "failed\n");
+		QL_PRINT_2(ha, "failed\n");
 	}
 
 #endif /* QL_DEBUG_ROUTINES */
@@ -10724,9 +11115,9 @@
 static int
 ql_kstat_update(kstat_t *ksp, int rw)
 {
-	int			rval;
+	int	rval;
 
-	QL_PRINT_3(CE_CONT, "started\n");
+	QL_PRINT_3(ksp->ks_private, "started\n");
 
 	if (rw == KSTAT_WRITE) {
 		rval = EACCES;
@@ -10736,10 +11127,10 @@
 
 	if (rval != 0) {
 		/*EMPTY*/
-		QL_PRINT_2(CE_CONT, "failed, rval = %xh\n", rval);
+		QL_PRINT_2(ksp->ks_private, "failed, rval = %xh\n", rval);
 	} else {
 		/*EMPTY*/
-		QL_PRINT_3(CE_CONT, "done\n");
+		QL_PRINT_3(ksp->ks_private, "done\n");
 	}
 	return (rval);
 }
@@ -10768,11 +11159,11 @@
 	uint32_t	size_to_compare;
 	int		erase_all;
 
-	if (CFG_IST(ha, CFG_CTRL_24258081)) {
+	if (CFG_IST(ha, CFG_ISP_FW_TYPE_2)) {
 		return (ql_24xx_load_flash(ha, dp, size, 0));
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	size_to_compare = 0x20000;
 	size_to_offset = 0;
@@ -10795,8 +11186,6 @@
 		return (rval);
 	}
 
-	GLOBAL_HW_LOCK();
-
 	/* Enable Flash Read/Write. */
 	ql_flash_enable(ha);
 
@@ -10820,13 +11209,11 @@
 
 	ql_flash_disable(ha);
 
-	GLOBAL_HW_UNLOCK();
-
 	if (rval != QL_SUCCESS) {
 		EL(ha, "failed=%xh\n", rval);
 	} else {
 		/*EMPTY*/
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+		QL_PRINT_3(ha, "done\n");
 	}
 	return (rval);
 }
